Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/Execute_queue/src/Execute_queue_vhdl_declaration.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/Execute_queue/src/Execute_queue_vhdl_declaration.cpp	(revision 97)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/Execute_queue/src/Execute_queue_vhdl_declaration.cpp	(revision 98)
@@ -25,37 +25,112 @@
     log_printf(FUNC,Execute_queue,FUNCTION,"Begin");
 
-    for (uint32_t i=0; i<_param->_size_queue; ++i)
+    vhdl->set_alias  ("internal_QUEUE_INSERT_VAL     ",1," in_EXECUTE_QUEUE_IN_VAL",std_logic_range(1));
+    vhdl->set_alias  ("internal_QUEUE_INSERT_ACK     ",1,"out_EXECUTE_QUEUE_IN_ACK",std_logic_range(1));
+    vhdl->set_signal ("internal_QUEUE_INSERT_DATA    ",_param->_size_internal_queue);
+    vhdl->set_signal ("internal_QUEUE_RETIRE_DATA    ",_param->_size_internal_queue);
+    vhdl->set_alias  ("internal_QUEUE_RETIRE_VAL     ",1,"out_EXECUTE_QUEUE_OUT_VAL",std_logic_range(1));
+    vhdl->set_alias  ("internal_QUEUE_RETIRE_ACK     ",1," in_EXECUTE_QUEUE_OUT_ACK",std_logic_range(1));
+
+    uint32_t min = 0;
+    uint32_t max, size;
+
+    if(_param->_have_port_context_id   )
       {
-	if (_param->_have_port_context_id)
-	  vhdl->set_signal("reg_CONTEXT_ID_"+toString(i),_param->_size_context_id);
-	if (_param->_have_port_front_end_id)
-	  vhdl->set_signal("reg_FRONT_END_ID_"+toString(i),_param->_size_front_end_id);
-	if (_param->_have_port_ooo_engine_id)
-	  vhdl->set_signal("reg_OOO_ENGINE_ID_"+toString(i),_param->_size_ooo_engine_id);
-	if (_param->_have_port_rob_ptr)
-	  vhdl->set_signal("reg_PACKET_ID_"+toString(i),_param->_size_rob_ptr);
-	vhdl->set_signal("reg_FLAGS_"+toString(i),_param->_size_special_data);
-	vhdl->set_signal("reg_EXCEPTION_"+toString(i),_param->_size_exception);
-	vhdl->set_signal("reg_NO_SEQUENCE_"+toString(i),1);
-	vhdl->set_signal("reg_ADDRESS_"+toString(i),_param->_size_instruction_address);
-	vhdl->set_signal("reg_DATA_"+toString(i),_param->_size_general_data);
+        size = _param->_size_context_id;
+        max = min-1+size;
+        vhdl->set_alias ("internal_EXECUTE_QUEUE_OUT_CONTEXT_ID           ",std_logic(size),"internal_QUEUE_RETIRE_DATA",std_logic_range(_param->_size_internal_queue,max,min));
+        min = max+1;
+      }
+    if(_param->_have_port_front_end_id   )
+      {
+        size = _param->_size_front_end_id;
+        max = min-1+size;
+        vhdl->set_alias ("internal_EXECUTE_QUEUE_OUT_FRONT_END_ID         ",std_logic(size),"internal_QUEUE_RETIRE_DATA",std_logic_range(_param->_size_internal_queue,max,min));
+        min = max+1;
+      }
+    if(_param->_have_port_ooo_engine_id   )
+      {
+        size = _param->_size_ooo_engine_id;
+        max = min-1+size;
+        vhdl->set_alias ("internal_EXECUTE_QUEUE_OUT_OOO_ENGINE_ID        ",std_logic(size),"internal_QUEUE_RETIRE_DATA",std_logic_range(_param->_size_internal_queue,max,min));
+        min = max+1;
+      }
+    if(_param->_have_port_rob_ptr)
+      {
+        size = _param->_size_rob_ptr;
+        max = min-1+size;
+        vhdl->set_alias ("internal_EXECUTE_QUEUE_OUT_PACKET_ID            ",std_logic(size),"internal_QUEUE_RETIRE_DATA",std_logic_range(_param->_size_internal_queue,max,min));
+        min = max+1;
       }
 
-    vhdl->set_signal("reg_CURRENT_STATE",_param->_size_queue+1);
+//  size = _param->_size_operation;
+//  max = min-1+size;
+//  vhdl->set_alias ("internal_EXECUTE_QUEUE_OUT_OPERATION            ",std_logic(size),"internal_QUEUE_RETIRE_DATA",std_logic_range(_param->_size_internal_queue,max,min));
+//  min = max+1;
+//
+//  size = _param->_size_type;
+//  max = min-1+size;
+//  vhdl->set_alias ("internal_EXECUTE_QUEUE_OUT_TYPE                 ",std_logic(size),"internal_QUEUE_RETIRE_DATA",std_logic_range(_param->_size_internal_queue,max,min));
+//  min = max+1;
 
-    vhdl->set_signal("sig_NEXT_STATE",_param->_size_queue+1);
+    size = _param->_size_special_data;
+    max = min-1+size;
+    vhdl->set_alias ("internal_EXECUTE_QUEUE_OUT_FLAGS                ",std_logic(size),"internal_QUEUE_RETIRE_DATA",std_logic_range(_param->_size_internal_queue,max,min));
+    min = max+1;
 
-    for (uint32_t i=0; i<_param->_size_queue-1; ++i)
-      {
-	vhdl->set_signal("sig_WEN_"+toString(i),1);
-	vhdl->set_signal("sig_SEL_"+toString(i),1);
-      }
-    vhdl->set_signal("sig_WEN_"+toString(_param->_size_queue - 1),1);
+    size = _param->_size_exception;    
+    max = min-1+size;
+    vhdl->set_alias ("internal_EXECUTE_QUEUE_OUT_EXCEPTION            ",std_logic(size),"internal_QUEUE_RETIRE_DATA",std_logic_range(_param->_size_internal_queue,max,min));
+    min = max+1;
 
-    vhdl->set_signal("sig_IN_ACK",1);
-    vhdl->set_signal("sig_OUT_VAL",1);
+    size = 1;
+    max = min-1+size;
+    vhdl->set_alias ("internal_EXECUTE_QUEUE_OUT_NO_SEQUENCE          ",std_logic(size),"internal_QUEUE_RETIRE_DATA",std_logic_range(_param->_size_internal_queue,max,min));
+    min = max+1;
 
-   for (uint32_t i=0; i<_param->_size_queue+1; ++i)
-      vhdl->set_constant("STATE_"+toString(i),_param->_size_queue+1,1<<i);
+    size = _param->_size_instruction_address;
+    max = min-1+size;
+    vhdl->set_alias ("internal_EXECUTE_QUEUE_OUT_ADDRESS              ",std_logic(size),"internal_QUEUE_RETIRE_DATA",std_logic_range(_param->_size_internal_queue,max,min));
+    min = max+1;
+
+    size = _param->_size_general_data;
+    max = min-1+size;
+    vhdl->set_alias ("internal_EXECUTE_QUEUE_OUT_DATA                 ",std_logic(size),"internal_QUEUE_RETIRE_DATA",std_logic_range(_param->_size_internal_queue,max,min));
+    min = max+1;
+
+
+//     for (uint32_t i=0; i<_param->_size_queue; ++i)
+//       {
+//      if (_param->_have_port_context_id)
+//      vhdl->set_signal("reg_CONTEXT_ID_"+toString(i),_param->_size_context_id);
+//      if (_param->_have_port_front_end_id)
+//      vhdl->set_signal("reg_FRONT_END_ID_"+toString(i),_param->_size_front_end_id);
+//      if (_param->_have_port_ooo_engine_id)
+//      vhdl->set_signal("reg_OOO_ENGINE_ID_"+toString(i),_param->_size_ooo_engine_id);
+//      if (_param->_have_port_rob_ptr)
+//      vhdl->set_signal("reg_PACKET_ID_"+toString(i),_param->_size_rob_ptr);
+//      vhdl->set_signal("reg_FLAGS_"+toString(i),_param->_size_special_data);
+//      vhdl->set_signal("reg_EXCEPTION_"+toString(i),_param->_size_exception);
+//      vhdl->set_signal("reg_NO_SEQUENCE_"+toString(i),1);
+//      vhdl->set_signal("reg_ADDRESS_"+toString(i),_param->_size_instruction_address);
+//      vhdl->set_signal("reg_DATA_"+toString(i),_param->_size_general_data);
+//       }
+
+//     vhdl->set_signal("reg_CURRENT_STATE",_param->_size_queue+1);
+
+//     vhdl->set_signal("sig_NEXT_STATE",_param->_size_queue+1);
+
+//     for (uint32_t i=0; i<_param->_size_queue-1; ++i)
+//       {
+//      vhdl->set_signal("sig_WEN_"+toString(i),1);
+//      vhdl->set_signal("sig_SEL_"+toString(i),1);
+//       }
+//     vhdl->set_signal("sig_WEN_"+toString(_param->_size_queue - 1),1);
+
+//     vhdl->set_signal("sig_IN_ACK",1);
+//     vhdl->set_signal("sig_OUT_VAL",1);
+
+//    for (uint32_t i=0; i<_param->_size_queue+1; ++i)
+//       vhdl->set_constant("STATE_"+toString(i),_param->_size_queue+1,1<<i);
 
     log_printf(FUNC,Execute_queue,FUNCTION,"End");
@@ -72,16 +147,2 @@
 }; // end namespace morpheo              
 #endif
-//   signal reg_0             : std_logic_vector (15 downto 0);
-//   signal reg_1             : std_logic_vector (15 downto 0);
-//   signal reg_2             : std_logic_vector (15 downto 0);
-//   signal reg_3             : std_logic_vector (15 downto 0);
-//   signal reg_CURRENT_STATE : std_logic_vector (4 downto 0);
-
-//   signal sig_NEXT_STATE    : std_logic_vector (4 downto 0);
-//   signal sig_WEN0          : std_logic;
-//   signal sig_SEL0          : std_logic;
-//   signal sig_WEN1          : std_logic;
-//   signal sig_SEL1          : std_logic;
-//   signal sig_WEN2          : std_logic;
-//   signal sig_SEL2          : std_logic;
-//   signal sig_WEN3          : std_logic;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/Execute_queue/src/Parameters.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/Execute_queue/src/Parameters.cpp	(revision 97)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/Execute_queue/src/Parameters.cpp	(revision 98)
@@ -38,4 +38,18 @@
 
     test();
+
+    _size_internal_queue = 
+      (log2( nb_context   )      +
+       log2( nb_front_end )      +
+       log2( nb_ooo_engine)      +
+       log2( nb_packet    )      +      
+//      size_operation           +
+//      size_type                +
+        size_special_data        +
+       _size_exception           +
+       1                         +
+        size_general_data        +
+        size_general_data 
+       );
 
     if (is_toplevel)
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/SelfTest/config_min.cfg
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/SelfTest/config_min.cfg	(revision 97)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/SelfTest/config_min.cfg	(revision 98)
@@ -4,5 +4,5 @@
 1	1	+1	# nb_inst_branch_complete
 0	0	+1	# size_depth                    [0] [nb_context]
-30	30	+1	# size_address			
+32	32	+1	# size_general_data		
 1	1	+1	# size_inst_decod               [0] [nb_decod_unit]
 1	1	+1	# size_inst_commit
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/SelfTest/config_mono_context.cfg
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/SelfTest/config_mono_context.cfg	(revision 97)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/SelfTest/config_mono_context.cfg	(revision 98)
@@ -4,5 +4,5 @@
 1	4	*4	# nb_inst_branch_complete
 0	2	+1	# size_depth                    [0] [nb_context]
-30	30	+1	# size_address			
+32	32	+1	# size_general_data		
 1	4	*4	# size_inst_decod               [0] [nb_decod_unit]
 1	4	*4	# size_inst_commit
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/SelfTest/config_multi_context.cfg
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/SelfTest/config_multi_context.cfg	(revision 97)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/SelfTest/config_multi_context.cfg	(revision 98)
@@ -11,5 +11,5 @@
 1	1	+1	# size_depth                    [6] [nb_context]
 0	0	+1	# size_depth                    [7] [nb_context]
-30	30	+1	# size_address			
+32	32	+1	# size_general_data		
 4	4	*4	# size_inst_decod               [0] [nb_decod_unit]
 1	1	*4	# size_inst_decod               [1] [nb_decod_unit]
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/SelfTest/src/main.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/SelfTest/src/main.cpp	(revision 97)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/SelfTest/src/main.cpp	(revision 98)
@@ -18,5 +18,5 @@
   err (_(" * nb_inst_branch_complete                       (uint32_t)\n"));
   err (_(" * size_depth                    [nb_context]	   (uint32_t)\n"));
-  err (_(" * size_address                                  (uint32_t)\n"));
+  err (_(" * size_general_data                             (uint32_t)\n"));
   err (_(" * size_inst_decod               [nb_decod_unit] (uint32_t)\n"));
   err (_(" * size_inst_commit                              (uint32_t)\n"));
@@ -52,5 +52,5 @@
     _size_depth [i] = fromString<uint32_t>(argv[x++]);
 
-  uint32_t   _size_address  = fromString<uint32_t>(argv[x++]);
+  uint32_t   _size_general_data = fromString<uint32_t>(argv[x++]);
 
   uint32_t * _size_inst_decod               = new uint32_t [_nb_decod_unit];
@@ -70,5 +70,5 @@
 	 _nb_inst_branch_complete      ,
 	 _size_depth                   ,
-	 _size_address                 ,
+	 _size_general_data            ,
 	 _size_inst_decod              ,
 	 _size_inst_commit             ,
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/SelfTest/src/test.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/SelfTest/src/test.cpp	(revision 97)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/SelfTest/src/test.cpp	(revision 98)
@@ -51,5 +51,5 @@
   ALLOC1_SC_SIGNAL(out_BRANCH_EVENT_ACK               ,"out_BRANCH_EVENT_ACK               ",Tcontrol_t   ,_param->_nb_context);
 //ALLOC1_SC_SIGNAL( in_BRANCH_EVENT_CONTEXT_ID        ," in_BRANCH_EVENT_CONTEXT_ID        ",Tcontext_t   ,_param->_nb_context);
-//ALLOC1_SC_SIGNAL( in_BRANCH_EVENT_DEPTH             ," in_BRANCH_EVENT_DEPTH             ",Tdepth_t     ,_param->_nb_context);
+  ALLOC1_SC_SIGNAL( in_BRANCH_EVENT_DEPTH             ," in_BRANCH_EVENT_DEPTH             ",Tdepth_t     ,_param->_nb_context);
 //ALLOC1_SC_SIGNAL( in_BRANCH_EVENT_MISS_PREDICTION   ," in_BRANCH_EVENT_MISS_PREDICTION   ",Tcontrol_t   ,_param->_nb_context);
   ALLOC1_SC_SIGNAL( in_BRANCH_EVENT_ADDRESS_SRC       ," in_BRANCH_EVENT_ADDRESS_SRC       ",Taddress_t   ,_param->_nb_context);
@@ -129,5 +129,6 @@
   INSTANCE1_SC_SIGNAL(_Context_State,out_BRANCH_EVENT_ACK               ,_param->_nb_context);
 //INSTANCE1_SC_SIGNAL(_Context_State, in_BRANCH_EVENT_CONTEXT_ID        ,_param->_nb_context);
-//INSTANCE1_SC_SIGNAL(_Context_State, in_BRANCH_EVENT_DEPTH             ,_param->_nb_context);
+  if (_param->_have_port_depth)				        
+  INSTANCE1_SC_SIGNAL(_Context_State, in_BRANCH_EVENT_DEPTH             ,_param->_nb_context);
 //INSTANCE1_SC_SIGNAL(_Context_State, in_BRANCH_EVENT_MISS_PREDICTION   ,_param->_nb_context);
   INSTANCE1_SC_SIGNAL(_Context_State, in_BRANCH_EVENT_ADDRESS_SRC       ,_param->_nb_context);
@@ -217,7 +218,8 @@
   srand(seed);
 
+  const  int32_t percent_transaction_branch_event    = 75;
   const  int32_t percent_transaction_decod_event     = 75;
   const  int32_t percent_transaction_commit_event    = 75;
-  const  int32_t percent_transaction_branch_complete = 75;
+//const  int32_t percent_transaction_branch_complete = 75;
   const  int32_t percent_transaction_event           = 75;
   const  int32_t percent_transaction_spr             = 75;
@@ -239,6 +241,8 @@
 	in_DECOD_EVENT_VAL [i]->write(0);
       in_COMMIT_EVENT_VAL ->write(0);
-      for (uint32_t i=0; i<_param->_nb_inst_branch_complete; i++)
-	in_BRANCH_COMPLETE_VAL [i]->write(0);
+//       for (uint32_t i=0; i<_param->_nb_inst_branch_complete; i++)
+// 	in_BRANCH_COMPLETE_VAL [i]->write(0);
+      for (uint32_t i=0; i<_param->_nb_context; i++)
+	in_BRANCH_EVENT_VAL [i]->write(0);
 
       for (uint32_t i=0; i<_param->_nb_context; i++)
@@ -525,25 +529,45 @@
 	  in_NB_INST_COMMIT_MEM [context]->write(1);
 	  
-	  uint32_t port = rand()%_param->_nb_inst_branch_complete;
-	  
-	  in_BRANCH_COMPLETE_CONTEXT_ID       [port]->write(context);
+// 	  uint32_t port = rand()%_param->_nb_inst_branch_complete;
+	  
+// 	  in_BRANCH_COMPLETE_CONTEXT_ID       [port]->write(context);
+// 	  if (_param->_have_port_depth)
+// 	  in_BRANCH_COMPLETE_DEPTH            [port]->write((_param->_array_size_depth[context]==0)?0:((context+1)%_param->_array_size_depth[context]));
+// 	  in_BRANCH_COMPLETE_ADDRESS_SRC      [port]->write(0x400);
+// 	  in_BRANCH_COMPLETE_ADDRESS_DEST     [port]->write(0x500);
+// 	  in_BRANCH_COMPLETE_MISS_PREDICTION  [port]->write(1);
+// 	  in_BRANCH_COMPLETE_TAKE             [port]->write(0);
+
+// 	  TEST(Tcontrol_t, out_CONTEXT_DECOD_ENABLE[context]->read(), 1);
+	  
+// 	  do
+// 	    {
+// 	      in_BRANCH_COMPLETE_VAL [port]->write(rand()%percent_transaction_branch_complete);
+	      
+// 	      SC_START(1);
+// 	    }
+// 	  while (not ( in_BRANCH_COMPLETE_VAL [port]->read() and
+// 		       out_BRANCH_COMPLETE_ACK [port]->read()));
+// 	  in_BRANCH_COMPLETE_VAL [port]->write(0);
+
+	  uint32_t port = context;
+	  
 	  if (_param->_have_port_depth)
-	  in_BRANCH_COMPLETE_DEPTH            [port]->write((_param->_array_size_depth[context]==0)?0:((context+1)%_param->_array_size_depth[context]));
-	  in_BRANCH_COMPLETE_ADDRESS_SRC      [port]->write(0x400);
-	  in_BRANCH_COMPLETE_ADDRESS_DEST     [port]->write(0x500);
-	  in_BRANCH_COMPLETE_MISS_PREDICTION  [port]->write(1);
-	  in_BRANCH_COMPLETE_TAKE             [port]->write(0);
-
-	  TEST(Tcontrol_t, out_CONTEXT_DECOD_ENABLE[context]->read(), 1);
-	  
-	  do
-	    {
-	      in_BRANCH_COMPLETE_VAL [port]->write(rand()%percent_transaction_branch_complete);
-	      
-	      SC_START(1);
-	    }
-	  while (not ( in_BRANCH_COMPLETE_VAL [port]->read() and
-		       out_BRANCH_COMPLETE_ACK [port]->read()));
-	  in_BRANCH_COMPLETE_VAL [port]->write(0);
+	  in_BRANCH_EVENT_DEPTH            [port]->write((_param->_array_size_depth[context]==0)?0:((context+1)%_param->_array_size_depth[context]));
+	  in_BRANCH_EVENT_ADDRESS_SRC      [port]->write(0x400);
+	  in_BRANCH_EVENT_ADDRESS_DEST     [port]->write(0x500);
+	  in_BRANCH_EVENT_ADDRESS_DEST_VAL [port]->write(0);
+
+	  TEST(Tcontrol_t, out_CONTEXT_DECOD_ENABLE[context]->read(), 1);
+	  
+	  do
+	    {
+	      in_BRANCH_EVENT_VAL [port]->write(rand()%percent_transaction_branch_event);
+	      
+	      SC_START(1);
+	    }
+	  while (not ( in_BRANCH_EVENT_VAL [port]->read() and
+		       out_BRANCH_EVENT_ACK [port]->read()));
+	  in_BRANCH_EVENT_VAL [port]->write(0);
 	  
 	  LABEL("miss (wait end)");
@@ -595,25 +619,44 @@
 	  in_NB_INST_COMMIT_MEM [context]->write(1);
 	  
-	  uint32_t port = rand()%_param->_nb_inst_branch_complete;
-	  
-	  in_BRANCH_COMPLETE_CONTEXT_ID       [port]->write(context);
-	  if (_param->_have_port_depth)
-	  in_BRANCH_COMPLETE_DEPTH            [port]->write((_param->_array_size_depth[context]==0)?0:((context+1)%_param->_array_size_depth[context]));
-	  in_BRANCH_COMPLETE_ADDRESS_SRC      [port]->write(0x600);
-	  in_BRANCH_COMPLETE_ADDRESS_DEST     [port]->write(0x700);
-	  in_BRANCH_COMPLETE_MISS_PREDICTION  [port]->write(1);
-	  in_BRANCH_COMPLETE_TAKE             [port]->write(1);
-
-	  TEST(Tcontrol_t, out_CONTEXT_DECOD_ENABLE[context]->read(), 1);
-	  
-	  do
-	    {
-	      in_BRANCH_COMPLETE_VAL [port]->write(rand()%percent_transaction_branch_complete);
-	      
-	      SC_START(1);
-	    }
-	  while (not ( in_BRANCH_COMPLETE_VAL [port]->read() and
-		       out_BRANCH_COMPLETE_ACK [port]->read()));
-	  in_BRANCH_COMPLETE_VAL [port]->write(0);
+// 	  uint32_t port = rand()%_param->_nb_inst_branch_complete;
+	  
+// 	  in_BRANCH_COMPLETE_CONTEXT_ID       [port]->write(context);
+// 	  if (_param->_have_port_depth)
+// 	  in_BRANCH_COMPLETE_DEPTH            [port]->write((_param->_array_size_depth[context]==0)?0:((context+1)%_param->_array_size_depth[context]));
+// 	  in_BRANCH_COMPLETE_ADDRESS_SRC      [port]->write(0x600);
+// 	  in_BRANCH_COMPLETE_ADDRESS_DEST     [port]->write(0x700);
+// 	  in_BRANCH_COMPLETE_MISS_PREDICTION  [port]->write(1);
+// 	  in_BRANCH_COMPLETE_TAKE             [port]->write(1);
+
+// 	  TEST(Tcontrol_t, out_CONTEXT_DECOD_ENABLE[context]->read(), 1);
+	  
+// 	  do
+// 	    {
+// 	      in_BRANCH_COMPLETE_VAL [port]->write(rand()%percent_transaction_branch_complete);
+	      
+// 	      SC_START(1);
+// 	    }
+// 	  while (not ( in_BRANCH_COMPLETE_VAL [port]->read() and
+// 		       out_BRANCH_COMPLETE_ACK [port]->read()));
+// 	  in_BRANCH_COMPLETE_VAL [port]->write(0);
+
+	  uint32_t port = context;
+	  
+	  in_BRANCH_EVENT_DEPTH            [port]->write((_param->_array_size_depth[context]==0)?0:((context+1)%_param->_array_size_depth[context]));
+	  in_BRANCH_EVENT_ADDRESS_SRC      [port]->write(0x600);
+	  in_BRANCH_EVENT_ADDRESS_DEST     [port]->write(0x700);
+	  in_BRANCH_EVENT_ADDRESS_DEST_VAL [port]->write(1);
+
+	  TEST(Tcontrol_t, out_CONTEXT_DECOD_ENABLE[context]->read(), 1);
+	  
+	  do
+	    {
+	      in_BRANCH_EVENT_VAL [port]->write(rand()%percent_transaction_branch_event);
+	      
+	      SC_START(1);
+	    }
+	  while (not ( in_BRANCH_EVENT_VAL [port]->read() and
+		       out_BRANCH_EVENT_ACK [port]->read()));
+	  in_BRANCH_EVENT_VAL [port]->write(0);
 	  
 	  LABEL("miss (wait end)");
@@ -1238,5 +1281,5 @@
   DELETE1_SC_SIGNAL(out_BRANCH_EVENT_ACK               ,_param->_nb_context);
 //DELETE1_SC_SIGNAL( in_BRANCH_EVENT_CONTEXT_ID        ,_param->_nb_context);
-//DELETE1_SC_SIGNAL( in_BRANCH_EVENT_DEPTH             ,_param->_nb_context);
+  DELETE1_SC_SIGNAL( in_BRANCH_EVENT_DEPTH             ,_param->_nb_context);
 //DELETE1_SC_SIGNAL( in_BRANCH_EVENT_MISS_PREDICTION   ,_param->_nb_context);
   DELETE1_SC_SIGNAL( in_BRANCH_EVENT_ADDRESS_SRC       ,_param->_nb_context);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/include/Context_State.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/include/Context_State.h	(revision 97)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/include/Context_State.h	(revision 98)
@@ -67,8 +67,8 @@
   public    : SC_OUT(Tcontrol_t         )  ** out_BRANCH_EVENT_ACK                   ;//[nb_context]
 //public    : SC_IN (Tcontext_t         )  **  in_BRANCH_EVENT_CONTEXT_ID            ;//[nb_context]
-//public    : SC_IN (Tdepth_t           )  **  in_BRANCH_EVENT_DEPTH                 ;//[nb_context]
-//public    : SC_IN (Tcontrol_t         )  **  in_BRANCH_EVENT_MISS_PREDICTION       ;//[nb_context]
+  public    : SC_IN (Tdepth_t           )  **  in_BRANCH_EVENT_DEPTH                 ;//[nb_context]
+//public    : SC_IN (Tcontrol_t         )  **  in_BRANCH_EVENT_MISS_PREDICTION       ;//[nb_context]// always
   public    : SC_IN (Taddress_t         )  **  in_BRANCH_EVENT_ADDRESS_SRC           ;//[nb_context]
-  public    : SC_IN (Tcontrol_t         )  **  in_BRANCH_EVENT_ADDRESS_DEST_VAL      ;//[nb_context]
+  public    : SC_IN (Tcontrol_t         )  **  in_BRANCH_EVENT_ADDRESS_DEST_VAL      ;//[nb_context]// take or not
   public    : SC_IN (Taddress_t         )  **  in_BRANCH_EVENT_ADDRESS_DEST          ;//[nb_context]
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/include/Parameters.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/include/Parameters.h	(revision 97)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/include/Parameters.h	(revision 98)
@@ -29,5 +29,5 @@
   public : uint32_t * _array_size_depth             ; //[nb_context]
 //public : uint32_t * _size_depth                   ; //[nb_context]
-//public : uint32_t   _size_address                 ;
+//public : uint32_t   _size_general_data            ;
 //public : uint32_t * _size_nb_inst_decod           ; //[nb_decod_unit]
 //public : uint32_t   _size_nb_inst_commit          ;
@@ -39,5 +39,5 @@
 			uint32_t   nb_inst_branch_complete,
 			uint32_t * size_depth,                
-			uint32_t   size_address,
+			uint32_t   size_general_data,
 			uint32_t * size_nb_inst_decod,           
 			uint32_t   size_nb_inst_commit,          
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/src/Context_State_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/src/Context_State_allocation.cpp	(revision 97)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/src/Context_State_allocation.cpp	(revision 98)
@@ -63,5 +63,5 @@
       ALLOC1_VALACK_OUT(out_BRANCH_EVENT_ACK                   ,ACK);
 //    ALLOC1_SIGNAL_IN ( in_BRANCH_EVENT_CONTEXT_ID            ,"context_id"             ,Tcontext_t         ,_param->_size_context_id);
-//    ALLOC1_SIGNAL_IN ( in_BRANCH_EVENT_DEPTH                 ,"depth"                  ,Tdepth_t           ,_param->_size_depth);
+      ALLOC1_SIGNAL_IN ( in_BRANCH_EVENT_DEPTH                 ,"depth"                  ,Tdepth_t           ,_param->_size_depth);
 //    ALLOC1_SIGNAL_IN ( in_BRANCH_EVENT_MISS_PREDICTION       ,"miss_prediction"        ,Tcontrol_t         ,1);
       ALLOC1_SIGNAL_IN ( in_BRANCH_EVENT_ADDRESS_SRC           ,"address_src"            ,Taddress_t         ,_param->_size_instruction_address);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/src/Context_State_deallocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/src/Context_State_deallocation.cpp	(revision 97)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/src/Context_State_deallocation.cpp	(revision 98)
@@ -31,5 +31,5 @@
         DELETE1_SIGNAL(out_BRANCH_EVENT_ACK                   ,_param->_nb_context,1);
 //      DELETE1_SIGNAL( in_BRANCH_EVENT_CONTEXT_ID            ,_param->_nb_context,_param->_size_context_id);
-//      DELETE1_SIGNAL( in_BRANCH_EVENT_DEPTH                 ,_param->_nb_context,_param->_size_depth);
+        DELETE1_SIGNAL( in_BRANCH_EVENT_DEPTH                 ,_param->_nb_context,_param->_size_depth);
 //      DELETE1_SIGNAL( in_BRANCH_EVENT_MISS_PREDICTION       ,_param->_nb_context,1);
         DELETE1_SIGNAL( in_BRANCH_EVENT_ADDRESS_SRC           ,_param->_nb_context,_param->_size_instruction_address);
